﻿'
'VeryLongFloating Caluculation(Excel2007 AddIn/NetFramework4.0)
'H23.3.1 V1
'
'y sakuda
'
'最大有効桁数は30,000（クラスの先頭のcNで指定する）
'（Excelのセルの表示が32,767文字から決めたもの。理論上はVBのIntegerまで可能）
'最大指数部は-9,223,372,036,854,775,808 から 9,223,372,036,854,775,807
'ただし、小数点が先頭にあるものとして
'
Imports System.Data
Imports System.Runtime.InteropServices
Imports Excel = Microsoft.Office.Interop.Excel
Imports System.Numerics
Imports System.Globalization
Public Structure VLFloating
    Dim VLFExp As Long
    Dim VLFBody As String
End Structure
<ComVisible(True)> _
Public Interface IVLF
    Function FVLFAbs(ByVal pN As Integer, ByVal pXX As String, ByRef pErr As Integer) As String
    Function FVLFCS(ByVal pN As Integer, ByVal wXX As String, ByRef pErr As Integer) As String
    Function FVLFZeroCheck(ByVal pN As Integer, ByVal pXX As String, ByRef pErr As Integer) As Boolean
    Function FVLFTrunc(ByVal pN As Integer, ByVal pXX As String, ByRef pErr As Integer) As String
    Function FVLFFraction(ByVal pN As Integer, ByVal pXX As String, ByRef pErr As Integer) As String
    Function FVLFIDiv(ByVal pN As Integer, ByVal pXX As String, ByVal pYY As String, _
                     ByRef pErr As Integer) As String
    Function FVLFMod(ByVal pN As Integer, ByVal pXX As String, ByVal pYY As String, _
                     ByRef pErr As Integer) As String
    Function FVLFCmp(ByVal pN As Integer, ByVal pXX As String, ByVal pYY As String, _
                     ByRef pErr As Integer) As Integer
    Function FVLFPower(ByVal pN As Integer, ByVal pXX As String, ByVal pYY As Integer, _
                     ByRef pErr As Integer) As String
    Function FVLFSub(ByVal pN As Integer, ByVal pXX As String, ByVal pYY As String, _
                     ByRef pErr As Integer) As String
    Function FVLFAdd(ByVal pN As Integer, ByVal pXX As String, ByVal pYY As String, _
                     ByRef pErr As Integer) As String
    Function FVLFMult(ByVal pN As Integer, ByVal pXX As String, ByVal pYY As String, _
                      ByRef pErr As Integer) As String
    Function FVLFDiv(ByVal pN As Integer, ByVal pXX As String, ByVal pYY As String, _
                     ByRef pErr As Integer) As String
    Function FVLFAbsDectoHex(ByVal pX As String, ByRef pErr As Integer) As String
    Function FVLFHextoAbsDec(ByVal pStr As String, ByRef pErr As Integer) As String
End Interface

<ComVisible(True)> _
<ClassInterface(ClassInterfaceType.None)> _
Public Class VLF
    Implements IVLF
    Public Const cN = 30000
    '
    '後０のトリム
    '
    Function TailZeroTrim(ByVal pBody As String) As String
        Dim IX As Integer, wLn As Integer, wEndIx As Integer, wCnt As Integer
        Dim wBody As String, wFlg As Boolean
        wBody = pBody
        wLn = Len(wBody)
        If Left(wBody, 1) = "-" Then
            wEndIx = 3
        Else
            wEndIx = 2
        End If
        wCnt = 0
        IX = wLn
        wFlg = wLn >= wEndIx
        Do While wFlg
            If Mid(wBody, IX, 1) = "0" Then
                IX = IX - 1
                wCnt = wCnt + 1
            Else
                wFlg = False
            End If
            If IX < wEndIx Then
                wFlg = False
            End If
        Loop
        TailZeroTrim = Left(wBody, wLn - wCnt)
    End Function
    '
    '有効外桁の丸め
    '
    Sub TailRound(ByVal pN As Integer, ByVal pSign As Integer, ByRef pExp As Long, ByRef pBody As String)
        Dim wRsltLn As Integer, wRes As Integer
        Dim wBIW As BigInteger, wBody As String
        wRsltLn = Len(pBody)
        If pSign = 1 Then
            wRsltLn = wRsltLn - 1
        End If
        wBody = pBody
        If wRsltLn > pN Then
            wRes = CInt(Mid(wBody, pN + pSign + 1, 1))
            If wRes > 4 Then
                wBIW = BigInteger.Parse(Left(wBody, pN + pSign))
                If pSign = 0 Then
                    wBIW = wBIW + 1
                Else
                    wBIW = wBIW - 1
                End If
                wBody = wBIW.ToString
                If pN + pSign < Len(wBody) Then
                    pExp = pExp + 1
                End If
            End If
        End If
        pBody = Left(wBody, pN + pSign)
    End Sub
    '
    'VeryLongFlotingの符号を除いた桁数
    '
    Function VLFLn(ByVal pX As VLFloating) As Integer
        VLFLn = Len(VLFAbs(pX).VLFBody)
    End Function
    '
    'VeryLongFloating ZeroCheck
    '
    Function VLFZeroCheck(ByVal pX As VLFloating) As Boolean
        Dim I As Integer, wLn As Integer, wBody As String, wFlg As Boolean
        wFlg = True
        wBody = pX.VLFBody
        wLn = Len(wBody)
        For I = 1 To wLn
            If Mid(wBody, I, 1) <> "0" Then
                wFlg = False
                Exit For
            End If
        Next
        VLFZeroCheck = wFlg
    End Function
    '
    ' VLF ZeroCheck Addin
    '
    Function FVLFZeroCheck(ByVal pN As Integer, ByVal pXX As String, ByRef pErr As Integer) As Boolean _
        Implements IVLF.FVLFZeroCheck
        Dim wXX As VLFloating
        pErr = 0
        wXX = SVConv(pN, pXX, pErr)
        FVLFZeroCheck = VLFZeroCheck(wXX)
    End Function
    '
    '文字列数字をVeryLongFloatingに変換
    '
    Function SVConv(ByVal pN As Integer, ByVal pS As String, ByRef pErr As Integer) As VLFloating
        Dim wResult As New VLFloating
        Dim wStr As String, wSExp As String, wUStr As String, wLStr As String
        Dim wUL As Integer, wLL As Integer
        Dim wPos As Integer, wExp As Long, wSign As Integer, I As Integer, wFlg As Boolean
        Dim wChr As String, wChrC As Integer
        If pN = 0 Or pN > cN Then
            pErr = 13
            SVConv = wResult
            Exit Function
        End If
        Try
            pErr = 0
            wStr = LCase(pS)
            wPos = InStr(wStr, "e")
            If wPos > 0 Then
                wSExp = Right(wStr, Len(wStr) - wPos)
                wStr = Left(wStr, wPos - 1)
            Else
                wSExp = ""
            End If
            wPos = InStr(wStr, ".")
            If wPos > 0 Then
                wUStr = Left(wStr, wPos - 1)
                wLStr = Right(wStr, Len(wStr) - wPos)
            Else
                wUStr = wStr
                wLStr = ""
            End If
            wChr = Left(wUStr, 1)
            If wChr = "-" Then
                wSign = 1
                wUStr = Right(wUStr, Len(wUStr) - 1)
            Else
                wSign = 0
                If wChr = "+" Then
                    wUStr = Right(wUStr, Len(wUStr) - 1)
                End If
            End If
            If Len(wSExp) > 0 Then
                Try
                    wExp = CLng(wSExp)
                Catch ex As Exception
                    pErr = 12
                    wResult.VLFExp = 0
                    wResult.VLFBody = "0"
                    SVConv = wResult
                    Exit Function
                End Try
            Else
                wExp = 0
            End If
            wUL = Len(wUStr)
            wLL = Len(wLStr)
            wStr = wUStr & wLStr
            wPos = 1
            wFlg = True
            For I = 1 To wUL + wLL
                wChrC = Asc(Mid(wStr, I, 1))
                If wFlg Then
                    If wChrC = 48 Then
                        wPos = wPos + 1
                    Else
                        wFlg = False
                    End If
                End If
                If wChrC < 48 Or wChrC > 57 Then
                    pErr = 11
                    wResult.VLFExp = 0
                    wResult.VLFBody = "0"
                    SVConv = wResult
                    Exit Function
                End If
            Next
            If wPos > wUL + wLL Then
                wResult.VLFExp = 0
                wResult.VLFBody = "0"
            Else
                wStr = Right(wStr, wUL + wLL - wPos + 1)
                wStr = TailZeroTrim(wStr)
                If Len(wStr) > pN Then
                    pErr = 1
                    wStr = Left(wStr, pN)
                End If
                wExp = wExp + wUL - wPos + 1
                If wSign = 1 Then
                    wStr = "-" & wStr
                End If
                wResult.VLFExp = wExp
                wResult.VLFBody = TailZeroTrim(Left(wStr, pN))
            End If
        Catch es As Exception
            pErr = 14
        End Try
        SVConv = wResult
    End Function
    '
    'VeryLongFloatingを文字列に変換
    '
    Function VSConv(ByVal pVF As VLFloating) As String
        Dim wStr As String, wSign As String, wExp As Long, wRslt As String, wLn As Integer
        Dim wUS As String, wLS As String
        wStr = pVF.VLFBody
        wExp = pVF.VLFExp
        If Left(wStr, 1) = "-" Then
            wSign = "-"
            wStr = Right(wStr, Len(wStr) - 1)
        Else
            wSign = ""
        End If
        wLn = Len(wStr)
        If wExp = Len(wStr) Then
            wRslt = wStr
        Else
            If wExp > 0 Then
                If wExp > 5 Then
                    wUS = Left(wStr, 1)
                    If wLn > 1 Then
                        wLS = Right(wStr, wLn - 1)
                    Else
                        wLS = "0"
                    End If
                    wRslt = wUS & "." & wLS & "E" & wExp - 1
                Else
                    If wLn < wExp Then
                        wStr = wStr & StrDup(CInt(wExp) - wLn, "0")
                        wLn = wExp
                    End If
                    wUS = Left(wStr, wExp)
                    If wLn > wExp Then
                        wLS = Right(wStr, wLn - wExp)
                    Else
                        wLS = ""
                    End If
                    wRslt = wUS
                    If wLS <> "" Then
                        wRslt = wRslt & "." & wLS
                    End If
                End If
            Else
                If wExp > -5 Then
                    If wStr = "0" Then
                        wRslt = "0"
                    Else
                        wRslt = "0." & StrDup(CInt(-wExp), "0") & wStr
                    End If
                Else
                    wRslt = "0." & wStr & "E" & wExp
                End If
            End If
        End If
        VSConv = wSign & wRslt
    End Function
    '
    'VeryLongFloating Absolute
    '
    Function VLFAbs(ByVal pX As VLFloating) As VLFloating
        Dim wBody As String
        wBody = pX.VLFBody
        If Left(wBody, 1) = "-" Then
            wBody = Right(wBody, Len(wBody) - 1)
        End If
        VLFAbs.VLFExp = pX.VLFExp
        VLFAbs.VLFBody = wBody
    End Function
    '
    ' VLF Absolute Addin
    '
    Function FVLFAbs(ByVal pN As Integer, ByVal pXX As String, ByRef pErr As Integer) As String _
        Implements IVLF.FVLFAbs
        Dim wXX As VLFloating
        pErr = 0
        wXX = SVConv(pN, pXX, pErr)
        If pErr > 0 Then
            FVLFAbs = "0"
        Else
            FVLFAbs = VSConv(VLFAbs(wXX))
        End If
    End Function
    '
    'VeryLongFloating Change Sign
    '
    Function VLFCS(ByVal pX As VLFloating) As VLFloating
        Dim wBody As String
        wBody = pX.VLFBody
        If Left(wBody, 1) = "-" Then
            wBody = Right(wBody, Len(wBody) - 1)
        Else
            If VLFZeroCheck(pX) = False Then
                wBody = "-" & wBody
            End If
        End If
        VLFCS.VLFExp = pX.VLFExp
        VLFCS.VLFBody = wBody
    End Function
    '
    ' VLF ChangeSign Addin
    '
    Function FVLFCS(ByVal pN As Integer, ByVal pXX As String, ByRef pErr As Integer) As String _
        Implements IVLF.FVLFCS
        Dim wXX As VLFloating
        pErr = 0
        wXX = SVConv(pN, pXX, pErr)
        If pErr > 0 Then
            FVLFCS = "0"
        Else
            FVLFCS = VSConv(VLFCS(wXX))
        End If
    End Function
    '
    'VeryLongFloating Compare
    '
    Function VLFCmp(ByVal pN As Integer, ByVal pX As VLFloating, ByVal pY As VLFloating, ByRef pErr As Integer) As Integer
        Dim wAns As VLFloating, wBody As String
        wAns = VLFSub(pN, pX, pY, pErr)
        If VLFZeroCheck(wAns) Then
            VLFCmp = 0
        Else
            wBody = wAns.VLFBody
            If Left(wBody, 1) = "-" Then
                VLFCmp = -1
            Else
                VLFCmp = 1
            End If
        End If
        If pErr = 31 Then
            pErr = 61
        End If
    End Function
    '
    ' VLF Compare Addin
    '
    Function FVLFCmp(ByVal pN As Integer, ByVal pXX As String, ByVal pYY As String, ByRef pErr As Integer) As Integer _
        Implements IVLF.FVLFCmp
        Dim wXX As VLFloating, wYY As VLFloating, wErr As Integer
        pErr = 0
        wXX = SVConv(pN, pXX, pErr)
        wYY = SVConv(pN, pYY, wErr)
        pErr = Math.Max(pErr, wErr)
        If pErr > 0 Then
            FVLFCmp = 0
        Else
            FVLFCmp = VLFCmp(pN, wXX, wYY, pErr)
        End If
    End Function
    '
    'VeryLongFroaling Trunc
    '
    Function VLFTrunc(ByVal pX As VLFloating) As VLFloating
        Dim wSign As Integer, wX As VLFloating, wExp As Long, wResult As VLFloating
        wSign = 0
        If Left(pX.VLFBody, 1) = "-" Then
            wSign = 1
        End If
        wX = VLFAbs(pX)
        wExp = pX.VLFExp
        If wExp <= 0 Then
            wResult.VLFExp = 0
            wResult.VLFBody = "0"
        Else
            wResult.VLFExp = wX.VLFExp
            wResult.VLFBody = Left(wX.VLFBody, wExp)
            If wSign > 0 Then
                wResult = VLFCS(wResult)
            End If
        End If
        VLFTrunc = wResult
    End Function
    '
    'VLF Trunc
    '
    Function FVLFTrunc(ByVal pN As Integer, ByVal pXX As String, ByRef pErr As Integer) As String _
        Implements IVLF.FVLFTrunc
        Dim wXX As VLFloating
        pErr = 0
        wXX = SVConv(pN, pXX, pErr)
        If pErr = 0 Then
            FVLFTrunc = VSConv(VLFTrunc(wXX))
        Else
            FVLFTrunc = "0"
        End If
    End Function
    '
    'VeryLongFroaling Fraction
    '
    Function VLFFraction(ByVal pN As Integer, ByVal pX As VLFloating, ByRef pErr As Integer) As VLFloating
        Dim wX As VLFloating
        wX = VLFTrunc(pX)
        VLFFraction = VLFSub(pN, pX, wX, pErr)
    End Function
    '
    'VLF Fraction
    '
    Function FVLFFraction(ByVal pN As Integer, ByVal pXX As String, ByRef pErr As Integer) As String _
        Implements IVLF.FVLFFraction
        Dim wXX As VLFloating
        pErr = 0
        wXX = SVConv(pN, pXX, pErr)
        If pErr = 0 Then
            FVLFFraction = VSConv(VLFFraction(pN, wXX, pErr))
        Else
            FVLFFraction = "0"
        End If
    End Function
    '
    'VeryLongFloating IDiv
    '
    Function VLFIDiv(ByVal pN As Integer, ByVal pX As VLFloating, ByVal pY As VLFloating, _
                     ByRef pErr As Integer) As VLFloating
        Dim wAns As VLFloating
        wAns = VLFDiv(pN, pX, pY, pErr)
        If pErr = 0 Then
            VLFIDiv = VLFTrunc(wAns)
        Else
            VLFIDiv.VLFExp = 0
            VLFIDiv.VLFBody = "0"
        End If
    End Function
    '
    ' VLF IDiv
    '
    Function FVLFIDiv(ByVal pN As Integer, ByVal pXX As String, ByVal pYY As String, _
                     ByRef pErr As Integer) As String Implements IVLF.FVLFIDiv
        Dim wXX As VLFloating, wYY As VLFloating, wErr As Integer
        pErr = 0
        wXX = SVConv(pN, pXX, pErr)
        wYY = SVConv(pN, pYY, wErr)
        pErr = Math.Max(pErr, wErr)
        If pErr > 0 Then
            FVLFIDiv = "0"
        Else
            FVLFIDiv = VSConv(VLFIDiv(pN, wXX, wYY, pErr))
        End If
    End Function
    '
    'VeryLongFloating Mod
    '
    Function VLFMod(ByVal pN As Integer, ByVal pX As VLFloating, ByVal pY As VLFloating, _
                     ByRef pErr As Integer) As VLFloating
        Dim wAns1 As VLFloating, wAns2 As VLFloating
        wAns1 = VLFIDiv(pN, pX, pY, pErr)
        If pErr = 0 Then
            wAns2 = VLFSub(pN, pX, VLFMult(pN, wAns1, pY, pErr), pErr)
            If pErr = 0 Then
                VLFMod = wAns2
            Else
                VLFMod.VLFExp = 0
                VLFMod.VLFBody = "0"
            End If
        Else
            VLFMod.VLFExp = 0
            VLFMod.VLFBody = "0"
        End If
    End Function
    '
    ' VLF Mod
    '
    Function FVLFMod(ByVal pN As Integer, ByVal pXX As String, ByVal pYY As String, _
                     ByRef pErr As Integer) As String Implements IVLF.FVLFMod
        Dim wXX As VLFloating, wYY As VLFloating, wErr As Integer
        pErr = 0
        wXX = SVConv(pN, pXX, pErr)
        wYY = SVConv(pN, pYY, wErr)
        pErr = Math.Max(pErr, wErr)
        If pErr > 0 Then
            FVLFMod = "0"
        Else
            FVLFMod = VSConv(VLFMod(pN, wXX, wYY, pErr))
        End If
    End Function
    '
    'VeryLongFloating Power
    '
    Function VLFPower(ByVal pN As Integer, ByVal pX As VLFloating, ByVal pY As Integer, _
                      ByRef pErr As Integer) As VLFloating
        Dim wY As Integer, wRslt As VLFloating, wPower As VLFloating, wOne As VLFloating
        Dim wSign As Boolean
        wRslt.VLFExp = 1
        wRslt.VLFBody = "1"
        wOne = wRslt
        wPower = pX
        wSign = pY < 0
        If pY = 0 Then
            VLFPower = wRslt
            Exit Function
        End If
        wY = Math.Abs(pY)
        Do While wY > 0
            If pErr > 0 Then
                pErr = 71
                Exit Do
            End If
            If wY Mod 2 > 0 Then
                wRslt = VLFMult(pN, wRslt, wPower, pErr)
            End If
            wY = wY \ 2
            If wY > 0 Then
                wPower = VLFMult(pN, wPower, wPower, pErr)
            End If
        Loop
        If wSign Then
            VLFPower = VLFDiv(pN, wOne, wRslt, pErr)
        Else
            VLFPower = wRslt
        End If
    End Function
    '
    'VLF Power Addin
    '
    Function FVLFPower(ByVal pN As Integer, ByVal pXX As String, ByVal pYY As Integer, ByRef pErr As Integer) _
        As String Implements IVLF.FVLFPower
        Dim wXX As VLFloating, wRslt As VLFloating
        pErr = 0
        wRslt.VLFBody = "0"
        wXX = SVConv(pN, pXX, pErr)
        If pErr = 0 Then
            wRslt = VLFPower(pN, wXX, pYY, pErr)
        End If
        FVLFPower = VSConv(wRslt)
    End Function
    '
    'VeryLongFloating Sub
    '
    Function VLFSub(ByVal pN As Integer, ByVal pX As VLFloating, ByVal pY As VLFloating, ByRef pErr As Integer) As VLFloating
        VLFSub = VLFAdd(pN, pX, VLFCS(pY), pErr)
    End Function
    '
    ' VLF Sub Addin
    '
    Function FVLFSub(ByVal pN As Integer, ByVal pXX As String, ByVal pYY As String, ByRef pErr As Integer) _
        As String Implements IVLF.FVLFSub
        Dim wXX As VLFloating, wYY As VLFloating, wErr As Integer
        pErr = 0
        wXX = SVConv(pN, pXX, pErr)
        wYY = SVConv(pN, pYY, wErr)
        pErr = Math.Max(pErr, wErr)
        If pErr > 0 Then
            FVLFSub = "0"
        Else
            FVLFSub = VSConv(VLFSub(pN, wXX, wYY, pErr))
        End If
        If pErr = 21 Then
            pErr = 31
        End If
    End Function

    '
    'VeryLongFloating Add
    '
    Function VLFAdd(ByVal pN As Integer, ByVal pX As VLFloating, ByVal pY As VLFloating, ByRef pErr As Integer) As VLFloating
        Dim wStr1 As String, wStr2 As String
        Dim wLn1 As Integer, wLn2 As Integer, wLnA As Integer
        Dim wBIX As New BigInteger, wBIY As New BigInteger, wBIA As BigInteger
        Dim wExp As Long, wExpX As Long, wExpY As Long, wBody As String, wSign As Integer
        Dim wD1 As Long, wD2 As Long, wOffset As Integer
        VLFAdd.VLFExp = 0
        VLFAdd.VLFBody = "0"
        Try
            wStr1 = pX.VLFBody
            wStr2 = pY.VLFBody
            wLn1 = VLFLn(pX)
            wLn2 = VLFLn(pY)
            wExpX = pX.VLFExp
            wExpY = pY.VLFExp
            wExp = Math.Max(wExpX, wExpY)
            wD1 = wExpX - wLn1
            wD2 = wExpY - wLn2
            If Math.Max(wD1, wD2) - Math.Min(wExpX, wExpY) > pN + 1 Then
                If wExpX > wExpY Then
                    If VLFZeroCheck(pX) Then
                        VLFAdd = pY
                    Else
                        VLFAdd = pX
                    End If
                Else
                    If VLFZeroCheck(pY) Then
                        VLFAdd = pX
                    Else
                        VLFAdd = pY
                    End If
                End If
            Else
                wOffset = Math.Abs(wD1 - wD2)
                If wD1 > wD2 Then
                    wStr1 = wStr1 & StrDup(wOffset, "0")
                    wLn1 = wLn1 + wOffset
                Else
                    wStr2 = wStr2 & StrDup(wOffset, "0")
                    wLn2 = wLn2 + wOffset
                End If
                wBIX = BigInteger.Parse(wStr1)
                wBIY = BigInteger.Parse(wStr2)
                wBIA = wBIX + wBIY
                wBody = wBIA.ToString
                wLnA = Len(wBody)
                wSign = 0
                If Left(wBody, 1) = "-" Then
                    wLnA = wLnA - 1
                    wSign = 1
                End If
                wExp = wExp + (wLnA - Math.Max(wLn1, wLn2))
                TailRound(pN, wSign, wExp, wBody)
                wBody = TailZeroTrim(wBody)
                VLFAdd.VLFExp = wExp
                VLFAdd.VLFBody = wBody
            End If
        Catch ex As Exception
            pErr = 21
        End Try
    End Function
    '
    ' VLF Add Addin
    '
    Function FVLFAdd(ByVal pN As Integer, ByVal pXX As String, ByVal pYY As String, ByRef pErr As Integer) _
        As String Implements IVLF.FVLFAdd
        Dim wXX As VLFloating, wYY As VLFloating, wErr As Integer
        pErr = 0
        wXX = SVConv(pN, pXX, pErr)
        wYY = SVConv(pN, pYY, wErr)
        pErr = Math.Max(pErr, wErr)
        If pErr >= 10 Then
            FVLFAdd = "0"
        Else
            FVLFAdd = VSConv(VLFAdd(pN, wXX, wYY, pErr))
        End If
    End Function
    '
    'VeryLongFloating Multiply
    '
    Function VLFMult(ByVal pN As Integer, ByVal pX As VLFloating, ByVal pY As VLFloating, _
                                                                  ByRef pErr As Integer) As VLFloating
        Dim wStr1 As String, wStr2 As String
        Dim wLn1 As Integer, wLn2 As Integer
        Dim wBIX As New BigInteger, wBIY As New BigInteger
        Dim wExp As Long, wBody As String, wSign As Integer, wRsltLn As Integer
        wBody = "0"
        wStr1 = pX.VLFBody
        wStr2 = pY.VLFBody
        wLn1 = VLFLn(pX)
        wLn2 = VLFLn(pY)
        Try
            wExp = pX.VLFExp + pY.VLFExp - 1
            wBIX = BigInteger.Parse(wStr1)
            wBIY = BigInteger.Parse(wStr2)
            wBody = (wBIX * wBIY).ToString
            If Left(wBody, 1) = "-" Then
                wSign = 1
            Else
                wSign = 0
            End If
            wRsltLn = Len(wBody) - wSign
            If wLn1 + wLn2 = wRsltLn Then
                wExp = wExp + 1
            End If
            TailRound(pN, wSign, wExp, wBody)
            wBody = TailZeroTrim(wBody)
        Catch es As Exception
            pErr = 41
        End Try
        VLFMult.VLFExp = wExp
        VLFMult.VLFBody = wBody
    End Function
    '
    ' VLF Mult Addin
    '
    Function FVLFmult(ByVal pN As Integer, ByVal pXX As String, ByVal pYY As String, _
                      ByRef pErr As Integer) As String Implements IVLF.FVLFMult
        Dim wXX As VLFloating, wYY As VLFloating, wErr As Integer
        pErr = 0
        wXX = SVConv(pN, pXX, pErr)
        wYY = SVConv(pN, pYY, wErr)
        pErr = Math.Max(pErr, wErr)
        If pErr >= 10 Then
            FVLFmult = "0"
        Else
            FVLFmult = VSConv(VLFMult(pN, wXX, wYY, pErr))
        End If
    End Function
    '
    'VeryLongFloating Divide
    '
    Function VLFDiv(ByVal pN As Integer, ByVal pX As VLFloating, ByVal pY As VLFloating, _
                                                             ByRef pErr As Integer) As VLFloating
        Dim wStr1 As String, wStr2 As String
        Dim wLn1 As Integer, wLn2 As Integer, wLnA As Integer
        Dim wBIX As New BigInteger, wBIY As New BigInteger, wBIA As BigInteger
        Dim wExp As Long, wBody As String, wSign As Integer
        If VLFZeroCheck(pY) Then
            wBody = "0"
            wExp = 0
            pErr = 52
        Else
            wBody = "0"
            wStr1 = pX.VLFBody
            wStr2 = pY.VLFBody
            wLn1 = VLFLn(pX)
            wLn2 = VLFLn(pY)
            Try
                wExp = pX.VLFExp - pY.VLFExp
                wStr1 = wStr1 & StrDup(CInt(pN - (wLn1 - wLn2) + 1), "0")
                wBIX = BigInteger.Parse(wStr1)
                wBIY = BigInteger.Parse(wStr2)
                wBIA = wBIX / wBIY
                wBody = wBIA.ToString
                wLnA = Len(wBody)
                wSign = 0
                If Left(wBody, 1) = "-" Then
                    wSign = 1
                    wLnA = wLnA - 1
                End If
                If wLnA > pN + 1 Then
                    wExp = wExp + 1
                End If
                TailRound(pN, wSign, wExp, wBody)
                wBody = TailZeroTrim(wBody)
            Catch es As Exception
                pErr = 51
            End Try
        End If
        VLFDiv.VLFExp = wExp
        VLFDiv.VLFBody = wBody
    End Function
    '
    ' VLF Div Addin
    '
    Function FVLFDiv(ByVal pN As Integer, ByVal pXX As String, ByVal pYY As String, ByRef pErr As Integer) _
        As String Implements IVLF.FVLFDiv
        Dim wXX As VLFloating, wYY As VLFloating, wErr As Integer
        pErr = 0
        wXX = SVConv(pN, pXX, pErr)
        wYY = SVConv(pN, pYY, wErr)
        pErr = Math.Max(pErr, wErr)
        If pErr >= 10 Then
            FVLFDiv = "0"
        Else
            FVLFDiv = VSConv(VLFDiv(pN, wXX, wYY, pErr))
        End If
    End Function
    '
    '符号なしの10進数を16進数に変換
    '　マイナス符号は無視します
    '　（必要なら前ゼロを加えて必ず偶数桁のHexに変換します）
    '
    Function VLFAbsDectoHex(ByVal pX As String, ByRef pErr As Integer) As String _
        Implements IVLF.FVLFAbsDectoHex
        Dim wX As BigInteger, wStr As String
        Dim wLn As Integer
        pErr = 0
        Try
            wX = BigInteger.Parse(pX)
        Catch es As Exception
            wX = 0
            pErr = 201
        End Try
        wX = BigInteger.Abs(wX)
        wStr = wX.ToString("X")
        wLn = Len(wStr)
        If wLn Mod 2 = 1 Then
            wLn = wLn + 1
            wStr = "0" & wStr
        End If
        If Mid(wStr, 1, 2) = "00" And wLn > 2 Then
            wStr = Right(wStr, wLn - 2)
        End If
        VLFAbsDectoHex = wStr
    End Function
    '
    '16進数を符号なしの10進数に変換
    '
    Function VLFHextoAbsDec(ByVal pStr As String, ByRef pErr As Integer) As String _
        Implements IVLF.FVLFHextoAbsDec
        Dim wX As BigInteger
        pErr = 0
        Try
            wX = BigInteger.Parse("0" & pStr, System.Globalization.NumberStyles.HexNumber)
        Catch ex As Exception
            pErr = 200
            wX = 0
        End Try
        VLFHextoAbsDec = wX.ToString
    End Function
End Class
